from semantha_sdk.api.semantha_endpoint import SemanthaAPIEndpoint
from semantha_sdk.model.model_metadata import ModelMetadata
from semantha_sdk.model.model_metadata import ModelMetadataSchema
from semantha_sdk.rest.rest_client import RestClient

class ModelOnemetadataEndpoint(SemanthaAPIEndpoint):
    """ author semantha, this is a generated class do not change manually! 
    
    """

    @property
    def _endpoint(self) -> str:
        return self._parent_endpoint + f"/{self._id}"

    def __init__(
        self,
        session: RestClient,
        parent_endpoint: str,
        id: str,
    ) -> None:
        super().__init__(session, parent_endpoint)
        self._id = id


    def get(
        self,
    ) -> ModelMetadata:
        """
        Get metadata by id
        Args:
            """
        q_params = {}
    
        return self._session.get(self._endpoint, q_params=q_params).execute().to(ModelMetadataSchema)

    
    
    def delete(
        self,
    ) -> None:
        """
        Delete metadata by id
        """
        self._session.delete(
            url=self._endpoint,
        ).execute()

    def put(
        self,
        body: ModelMetadata
    ) -> ModelMetadata:
        """
        Update metadata by id
        """
        return self._session.put(
            url=self._endpoint,
            json=ModelMetadataSchema().dump(body)
        ).execute().to(ModelMetadataSchema)
